#include "USBMicroX.h"

int main(int argc, const char * argv[])
{
	// Grab a context (you really only need one of these per application)
	// All this function does is allocate and initialize some data structures
	USBmX_ContextRef ctx = USBmX_Create();
	
	// if you want to recieve plug and un-plug notifications, stick some calls
	// to USBmX_DeviceAddedHandler and USBmX_DeviceRemovedHandler here
	
	// This sets up all the dirty work for you.  you MUST call this before you can mess
	// with any devices
	USBmX_Begin(ctx);
	
	USBMX_LOG("There are %d device(s) connected.", USBmX_DeviceCount(ctx));
	
	// grab the default device (convinient if you only have 1 device connected,
	// so you don't have to mess with USBmX_DeviceWithSerial, this will generally
	// return the lasst device that was plugged in.
	USBmX_DeviceRef device = USBmX_DefaultDevice(ctx); // return NULL on error
	if(device)
	{
		//set direction
		USBmX_DirectionA(device, 0xFF, 0xFF);
		//write byte
		USBmX_WriteA(device, 0xFF);
	}
	
	//dont REALLY need this, but it's good practice
	USBmX_Destroy(ctx);
    return 0;
}
