#import <Cocoa/Cocoa.h>
#import "USBMicroX_ObjC.h"

int main(int argc, char *argv[])
{
	// Print the number of devices (the first call to any USBMicro
	// method will do all initializations internally).
	USBMLog("There are %d devices connected.", [USBMicro deviceCount]);

	USBMicroDevice *d = nil;
	if(d = [USBMicro defaultDevice])
	{
		// There a number of ways to do the following:
		// in order of complexity:
		
		//	method 1
		#if 1
		[[d outputA] setA:0xFF];
		#endif

		//	method 2
		#if 0
		[d outputA];
		[d setA:0xFF];
		#endif
		
		//	method 3
		#if 0
		[d directionA:0xFF with:0xFF];
		[d writeA:0xFF];
		#endif
		
		//	method 4
		#if 0
		USBmX_DeviceRef device = [d device]; // grab lower-level deviceRef
		USBmX_DirectionA(device, 0xFF, 0xFF);
		USBmX_WriteA(device, 0xFF);
		#endif
	}
	
	return 0;
}
