#import "IOPortController.h"
#import "IOController.h"

@implementation IOPortController

- (int)ioMode
{
	return ioMode;
}

- (IBAction)setIO:(id)sender
{
	USBMX_LOG("selected IO %d", [sender selectedSegment]);
	ioMode = [sender selectedSegment];
	[self sync:nil];
}

- (IBAction)updateValue:(id)sender
{
	USBMX_LOG("update value");
	int v = 0;
	v |= [bit0 state] << 0;
	v |= [bit1 state] << 1;
	v |= [bit2 state] << 2;
	v |= [bit3 state] << 3;
	v |= [bit4 state] << 4;
	v |= [bit5 state] << 5;
	v |= [bit6 state] << 6;
	v |= [bit7 state] << 7;
	[self setValueAndSync:v];
}

- (IBAction)sync:(id)sender
{
	USBMX_LOG("sync!");
	[controller sync];
}

- (int)value
{
	return value;
}

- (void)setValue:(int)v
{
	USBMX_LOG("set value  %d", v);
	value = v;
	[bit0 setState:v & (1 << 0)];
	[bit1 setState:v & (1 << 1)];
	[bit2 setState:v & (1 << 2)];
	[bit3 setState:v & (1 << 3)];
	[bit4 setState:v & (1 << 4)];
	[bit5 setState:v & (1 << 5)];
	[bit6 setState:v & (1 << 6)];
	[bit7 setState:v & (1 << 7)];
}

- (void)setValueAndSync:(int)v
{
	[self setValue:v];
	[self sync:nil];
}

@end
