#import <Cocoa/Cocoa.h>
#include "USBMicroX_ObjC.h"

@class CommandController;
@class IOController;

@interface USBGUIController : NSObject
{
	IBOutlet NSTextView* console;
	IBOutlet NSDrawer* consoleDrawer;
	IBOutlet NSTableView* deviceTable;
	IBOutlet NSTextField* deviceField;
	IBOutlet NSTextField* manufacturerField;
	IBOutlet NSTextField* serialField;
	IBOutlet NSButton* moreInfoButton;
	IBOutlet NSTabView* mainTabView;
	IBOutlet NSPanel* moreInfoPanel;
	IBOutlet NSTextView* moreInfoConsole;
	IBOutlet NSProgressIndicator* progress;
	
	IBOutlet CommandController* commandController;
	IBOutlet IOController* ioController;
}

// progress indicator
- (void)startLongWait;
- (void)endLongWait;

- (USBMicroDevice *)selectedDevice;

- (IBAction)toggleConsole:(id)sender;
- (IBAction)clearConsole:(id)sender;
- (IBAction)moreInfo:(id)sender;
- (IBAction)refreshList:(id)sender;
- (IBAction)clearMoreInfoConsole:(id)sender;

@end
