#import "USBMXMisc.h"

int USBMXIntegerFromHexNSString(NSString *string)
{
	unsigned int intValue;
	NSScanner *scanner = [NSScanner scannerWithString:string];
	if([scanner scanHexInt:&intValue] && ([scanner isAtEnd]))
	{
		return intValue;
	}
	return 0;
}

NSString* USBMXNSStringFromHexInteger(int hex)
{
	return [NSString stringWithFormat:@"0x%02X", hex];
}

void USBMXAppendNSTextView(NSTextView *t, NSString *s)
{
	int length = [[t string] length];
	NSRange range = NSMakeRange(length, 0);
	[t replaceCharactersInRange:range withString:s];
	[t scrollRangeToVisible:NSMakeRange(length + [s length], 0)];
}

void USBMXClearNSTextView(NSTextView *t)
{
	int length = [[t string] length];
	NSRange range = NSMakeRange(0, length);
	[t replaceCharactersInRange:range withString:@" "];
}
