unit usbmapi;

//-------------------------------------------------------------------------
// USBm USB dynamic link library Borland Delphi API
//
//
// Author:           Robert Severson (USBmicro) with considerable assistance
//                   from Mike McWhinney (elja, Incorporated).
//
// File:             USBmAPI.pas
//
// Creation Date:    2004-01-22
//
// Description:      USB DLL for U4xx
//
// Copyright:        Copyright (C), Robert R. Severson 2004. All rights
//                   reserved. Created in the year 2004 as an unpublished
//                   copyright work. This program and the information
//                   contained in it is property of Robert R. Severson
//                   and may not be used, copied, or reproduced without
//                   prior written permission of Robert R. Severson
//
//                   This file may be freely distributed for use when
//                   interfacing with the USBm.dll. This file is distributed
//                   in the hope that it will be useful, but without any
//                   warranty.
//
//                   This software remains the property of Robert R.
//                   Severson and is supplied under licence only. The use
//                   of this software is permitted under the terms of that
//                   licence only.
//
//---------------------------------------------------------------------------

interface

Function USBm_NumberOfDevices: smallint; stdcall;
Function USBm_DeviceValid(device:Byte):smallint; stdcall;
Function USBm_DeviceVID(device:Byte):smallint;stdcall;
Function USBm_DevicePID(device:Byte):smallint;stdcall;
Function USBm_DeviceDID(device:Byte):smallInt;stdcall;
Function USBm_DeviceMfr(device:Byte; Manufacturer:pchar):smallint; stdcall;
Function USBm_DeviceProd(device:Byte; Product:pchar):smallint; stdcall;
Function USBm_DeviceSer(device:Byte; Product:pchar):smallint; stdcall;
Function USBm_RecentError(errorstring:pchar):smallint; stdcall;
Function USBm_ClearRecentError:smallint; stdcall;
Function USBm_DebugString(debugstrng:pchar):smallint; stdcall;
Function USBm_WriteDevice(device:Byte;var data):smallint; stdcall;
Function USBm_ReadDevice(device:Byte;var data):smallint; stdcall;
Function USBm_SetReadTimeout(timeout:smallint):smallint; stdcall;
Function USBm_FindDevices:smallint; stdcall;
Function USBm_CloseDevice(device:Byte):smallint; stdcall;
Function USBm_Copyright(copyrightstring:pchar):smallint; stdcall;
Function USBm_About(aboutstring:pchar):smallint; stdcall;
Function USBm_Version(versionstring:pchar):smallint; stdcall;
Function USBm_InitPorts(device:Byte):smallint; stdcall;
Function USBm_WriteA(device:Byte;data:Byte):smallint; stdcall;
Function USBm_WriteB(device:Byte;data:Byte):smallint; stdcall;
Function USBm_WriteABit(device:Byte;and_term:Byte; or_term:Byte):smallint; stdcall;
Function USBm_WriteBBit(device:Byte;and_term:Byte; or_term:Byte):smallint; stdcall;
Function USBm_ReadA(device:Byte;var data:Byte):smallint; stdcall;
Function USBm_ReadB(device:Byte;var data:Byte):smallint; stdcall;
Function USBm_SetBit(device:Byte;bit:Byte):smallint; stdcall;
Function USBm_ResetBit(device:Byte;bit:Byte):smallint; stdcall;
Function USBm_DirectionA(device:Byte;dir0:Byte;Dir1:Byte):smallint; stdcall;
Function USBm_DirectionB(device:Byte;dir0:Byte;Dir1:Byte):smallint; stdcall;
Function USBm_StrobeWrite(device:Byte;data:Byte;Port:Byte;Sel:Byte):smallint; stdcall;
Function USBm_StrobeRead(device:Byte;var data:Byte;Port:Byte;Sel:Byte):smallint; stdcall;
Function USBm_InitLCD(device:Byte;sel:Byte;port:Byte):smallint; stdcall;
Function USBm_LCDCmd(device:Byte;data:Byte):smallint; stdcall;
Function USBm_LCDData(device:Byte;data:Byte):smallint; stdcall;
Function USBm_InitSPI(device:Byte;data:Byte):smallint; stdcall;
Function USBm_SPIMaster(device:Byte;var count:Byte;var data):smallint; stdcall;
Function USBm_SPISlaveWrite(device:Byte;index:Byte;var data):smallint; stdcall;
Function USBm_SPISlaveRead(device:Byte;var count:Byte;var data):smallint;stdcall;
Function USBm_Stepper(device:Byte;channel:Byte;enable:Byte;direction:Byte;steptype:Byte;initial:Byte;steprate:Byte):smallint; stdcall;
Function USBm_Reset1Wire(device:Byte;var data:Byte):smallint; stdcall;
Function USBm_Write1Wire(device:Byte;data:Byte):smallint; stdcall;
Function USBm_Read1Wire(device:Byte;var data:Byte):smallint; stdcall;


implementation

Function USBm_NumberOfDevices: smallint; stdcall; external 'USBm.dll';
Function USBm_DeviceValid(device:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_DeviceVID(device:Byte):smallint;stdcall; external 'USBm.dll';
Function USBm_DevicePID(device:Byte):smallint;stdcall; external 'USBm.dll';
Function USBm_DeviceDID(device:Byte):smallInt;stdcall; external 'USBm.dll';
Function USBm_DeviceMfr(device:Byte; Manufacturer:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_DeviceProd(device:Byte; Product:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_DeviceSer(device:Byte; Product:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_RecentError(errorstring:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_ClearRecentError:smallint; stdcall; external 'USBm.dll';
Function USBm_DebugString(debugstrng:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_WriteDevice(device:Byte;var data):smallint; stdcall; external 'USBm.dll';
Function USBm_ReadDevice(device:Byte;var data):smallint; stdcall; external 'USBm.dll';
Function USBm_SetReadTimeout(timeout:smallint):smallint; stdcall; external 'USBm.dll';
Function USBm_FindDevices:smallint; stdcall; external 'USBm.dll';
Function USBm_CloseDevice(device:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_Copyright(copyrightstring:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_About(aboutstring:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_Version(versionstring:pchar):smallint; stdcall; external 'USBm.dll';
Function USBm_InitPorts(device:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_WriteA(device:Byte;data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_WriteB(device:Byte;data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_WriteABit(device:Byte;and_term:Byte; or_term:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_WriteBBit(device:Byte;and_term:Byte; or_term:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_ReadA(device:Byte;var data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_ReadB(device:Byte;var data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_SetBit(device:Byte;bit:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_ResetBit(device:Byte;bit:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_DirectionA(device:Byte;dir0:Byte;Dir1:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_DirectionB(device:Byte;dir0:Byte;Dir1:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_StrobeWrite(device:Byte;data:Byte;Port:Byte;Sel:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_StrobeRead(device:Byte;var data:Byte;Port:Byte;Sel:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_InitLCD(device:Byte;sel:Byte;port:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_LCDCmd(device:Byte;data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_LCDData(device:Byte;data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_InitSPI(device:Byte;data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_SPIMaster(device:Byte;var count:Byte;var data):smallint; stdcall; external 'USBm.dll';
Function USBm_SPISlaveWrite(device:Byte;index:Byte;var data):smallint; stdcall; external 'USBm.dll';
Function USBm_SPISlaveRead(device:Byte;var count:Byte;var data):smallint;stdcall; external 'USBm.dll';
Function USBm_Stepper(device:Byte;channel:Byte;enable:Byte;direction:Byte;steptype:Byte;initial:Byte;steprate:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_Reset1Wire(device:Byte;var data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_Write1Wire(device:Byte;data:Byte):smallint; stdcall; external 'USBm.dll';
Function USBm_Read1Wire(device:Byte;var data:Byte):smallint; stdcall; external 'USBm.dll';


end.


