Attribute VB_Name = "MiscFunctions"
'================================================================================
' Misc VB Functions
'================================================================================

' File directives
Option Explicit




'--------------------------------------------------------------------------------
' Return a hex byte from a string
'--------------------------------------------------------------------------------
Public Function ReturnHexByte(Text$) As Byte

    ' Locals
    Dim value As Byte
    Dim Utext As String
    Dim HexString As String
    Dim i As Long
    
    
    ' Convert to upper case
    Utext$ = UCase(Text$)

    ' String of allowed hex characters
    HexString$ = "0123456789ABCDEF"

    value = 0

    For i& = 0 To 15
        If Mid(Utext$, 1, 1) = Mid(HexString$, i& + 1, 1) Then
            value = value + (16 * i&)
        End If

        If Mid(Utext$, 2, 1) = Mid(HexString$, i& + 1, 1) Then
            value = value + i&
        End If

    Next i&

    ReturnHexByte = value

End Function




'--------------------------------------------------------------------------------
' Return two ASCII hex characters when passed a byte
'--------------------------------------------------------------------------------
Public Function TwoHexCharacters$(value As Variant)

    Dim HexString As String

    HexString$ = "0123456789ABCDEF"

    TwoHexCharacters$ = Mid(HexString$, ((value And &HF0) / 16) + 1, 1) _
                      & Mid(HexString$, ((value And &HF) / 1) + 1, 1)

End Function




'--------------------------------------------------------------------------------
' Return four ASCII hex characters when passed an integer
'--------------------------------------------------------------------------------
Public Function FourHexCharacters$(value As Variant)
    
    Dim HexString As String
        
    HexString$ = "0123456789ABCDEF"

    FourHexCharacters$ = Mid(HexString$, ((value And &HF000) / 4096) + 1, 1) _
                       & Mid(HexString$, ((value And &HF00) / 256) + 1, 1) _
                       & Mid(HexString$, ((value And &HF0) / 16) + 1, 1) _
                       & Mid(HexString$, ((value And &HF) / 1) + 1, 1)

End Function




'--------------------------------------------------------------------------------
' Return two ASCII decimal characters when passed a byte
'--------------------------------------------------------------------------------
Public Function TwoDecimalCharacters$(value As Byte)

    Dim DecimalString$, Tens&, Units&
    
    DecimalString$ = "0123456789"

    Tens& = Int(value / 10)
    Units& = value - (10 * Tens&)

    TwoDecimalCharacters$ = Mid(DecimalString$, Tens& + 1, 1) & Mid(DecimalString$, Units& + 1, 1)

End Function




'--------------------------------------------------------------------------------
' Return three ASCII decimal characters when passed a byte
'--------------------------------------------------------------------------------
Public Function ThreeDecimalCharacters$(value As Byte)

    Dim h&, t&, u&

    h& = Int(value / 100)
    t& = Int((value - (100 * h&)) / 10)
    u& = value - (100 * h&) - (10 * t&)

    ThreeDecimalCharacters$ = h& & t& & u&

End Function




'--------------------------------------------------------------------------------
' Display message box with error
'--------------------------------------------------------------------------------
Public Sub ErrorExit(Reason$)

    Dim ErrorCode

'    ErrorCode = GetLastError()

    Call MsgBox(Reason$, vbCritical)

    Stop

End Sub




'--------------------------------------------------------------------------------
' Return the value (0 or 1) of the requested bit in a Variable.
'--------------------------------------------------------------------------------
Private Function Bit(Variable As Integer, BitNumber As Integer) As Integer

    Bit = (Variable And 2 ^ BitNumber) \ 2 ^ BitNumber

End Function




'--------------------------------------------------------------------------------
'
'--------------------------------------------------------------------------------
Private Function SetBit(Variable As Integer, BitNumber As Integer)
    
    Variable = Variable Or (2 ^ BitNumber)

End Function




'--------------------------------------------------------------------------------
'
'--------------------------------------------------------------------------------
Private Function ClearBit(Variable As Integer, BitNumber As Integer)

    Variable = Variable And (&HFFFF - (2 ^ BitNumber))

End Function


