Attribute VB_Name = "APIcalls"
'================================================================================
' APIcalls
'
' This module declares the data types and system calls required to access
' the Windows operating system
'
'================================================================================

Public Type Security_Attributes
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type


'A GUID is 16 bytes long
Public Type Guid
    Data(3) As Long
End Type


Public Type Device_Interface_Data
    cbsize As Long
    InterfaceClassGuid As Guid
    Flags As Long
    ReservedPtr As Long
End Type


Public Type Device_Interface_Detail
    cbsize As Long
    DataPath(256) As Byte
End Type


Public Type ConfigurationDataType
    cookie As Long
    cbsize As Long
    RingBuffersize As Long
End Type


Public Type HidD_Attributes
    cbsize As Long
    VendorID(1) As Byte
    ProductID(1) As Byte
    VersionNumber(1) As Byte
    Pad(10) As Byte
End Type





'   Declare the functions from Dan Appleman's "Programmers Guide to the Win32 API"
Declare Function AddressFor _
    Lib "apigid32.dll" _
    Alias "agGetAddressForObject" _
        (PassedByReference As Any) _
    As Long

Declare Sub CopyBuffer _
    Lib "apigid32.dll" _
    Alias "agCopyData" _
        (ByVal SourcePtr&, _
        ByVal DestPtr&, _
        ByVal ByteCount&)


'   Declare the API calls that I am using
Declare Sub HidD_GetHidGuid _
    Lib "HID.dll" _
        (GuidPtr&)


Declare Function SetupDiGetClassDevs _
    Lib "setupapi.dll" _
    Alias "SetupDiGetClassDevsA" _
        (GuidPtr&, _
        ByVal EnumPtr&, _
        ByVal HwndParent&, _
        ByVal Flags&) _
    As Long


Declare Function SetupDiDestroyDeviceInfoList _
    Lib "setupapi.dll" _
        (ByVal DeviceInfoSet&) _
    As Boolean


Declare Function SetupDiEnumDeviceInterfaces _
    Lib "setupapi.dll" _
        (ByVal Handle&, _
        ByVal InfoPtr&, _
        GuidPtr&, _
        ByVal MemberIndex&, _
        InterfaceDataPtr&) _
    As Boolean


Declare Function SetupDiGetDeviceInterfaceDetail _
    Lib "setupapi.dll" _
    Alias "SetupDiGetDeviceInterfaceDetailA" _
        (ByVal Handle&, _
        InterfaceDataPtr&, _
        InterfaceDetailPtr&, _
        ByVal DetailLength&, _
        ReturnedLengthPtr&, _
        ByVal DevInfoDataPtr&) _
    As Boolean


Declare Function GetLastError _
    Lib "kernel32" _
        () _
    As Long


Declare Function CreateFile _
    Lib "kernel32" _
    Alias "CreateFileA" _
        (ByVal lpFileName$, _
        ByVal dwDesiredAccess&, _
        ByVal dwShareMode&, _
        lpSecurityAttributes As Security_Attributes, _
        ByVal dwCreationDisposition&, _
        ByVal dwFlagsAndAttributes&, _
        ByVal hTemplateFile&) _
    As Long


Declare Sub CloseHandle _
    Lib "kernel32" _
        (ByVal HandleToClose As Long)


Declare Function ReadFile _
    Lib "kernel32" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal ByteCount&, _
        BytesReturnedPtr&, _
        ByVal OverlappedPtr&) _
    As Long


Declare Function WriteFile _
    Lib "kernel32" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal ByteCount&, _
        BytesReturnedPtr&, _
        ByVal OverlappedPtr&) _
    As Long


Declare Function DeviceIoControl _
    Lib "kernel32" _
        (ByVal hDevice&, _
        ByVal dwIoControlCode&, _
        lpInBuffer&, _
        ByVal nInBufferSize&, _
        lpOutBuffer&, _
        ByVal nOutBufferSize&, _
        lpBytesReturned&, _
        lpOverlapped&) _
    As Long


Declare Function HidD_GetPreparsedData _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&) _
    As Long


Declare Function HidD_GetAttributes _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByRef Attributes As HidD_Attributes) _
    As Long


Declare Function HidD_GetManufacturerString _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function HidD_GetProductString _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function HidD_GetSerialNumberString _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function HidD_GetIndexedString _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal index&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function HidD_GetConfiguration _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function HidD_SetConfiguration _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function HidD_GetPhysicalDescriptor _
    Lib "HID.dll" _
        (ByVal Handle&, _
        ByVal BufferPtr&, _
        ByVal Length&) _
    As Long


Declare Function changeValue _
    Lib "usbv1.dll" _
        (ByVal value As Byte, _
        ByVal whichOp As Byte) _
    As Byte
    
    

