
//*************************************************************************
//
// Author:           Robert Severson
//
// Creation Date:    2005-March
//
// Description:      BCB USBm.dll link to lib example
//
// Copyright:        Copyright (C), Robert R. Severson 2005. All rights
//                   reserved. Created in the year 2005 as an unpublished
//                   copyright work. This program and the information
//                   contained in it is property of Robert R. Severson
//                   and may not be used, copied, or reproduced without
//                   prior written permission of Robert R. Severson
//
//                   This software remains the property of Robert R.
//                   Severson and is supplied under license only. The use
//                   of this software is permitted under the terms of that
//                   license only.
//
//*************************************************************************

#include <vcl.h>
//#include <dstring.h>

#pragma hdrstop

#include "Unit1.h"

            
// Discovery routine
extern "C" __declspec(dllexport) int __stdcall USBm_FindDevices(void);

// Info about devices
extern "C" __declspec(dllexport) int __stdcall USBm_NumberOfDevices(void);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceValid(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceVID(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DevicePID(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceDID(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceMfr(unsigned char, char *);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceProd(unsigned char, char *);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceSer(unsigned char, char *);

// General U4xx functions
extern "C" __declspec(dllexport) int __stdcall USBm_InitPorts(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteA(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteB(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteABit(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteBBit(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_ReadA(unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_ReadB(unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_SetBit(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_ResetBit(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DirectionA(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DirectionB(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeWrite(unsigned char, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeRead(unsigned char, unsigned char *, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeWrite2(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeRead2(unsigned char, unsigned char *, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeWrites(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeReads(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_InitLCD(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_LCDCmd(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_LCDData(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_InitSPI(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_SPIMaster(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_SPISlaveWrite(unsigned char, unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_SPISlaveRead(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Stepper(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_Reset1Wire(unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Write1Wire(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_Read1Wire(unsigned char, unsigned char *);

// DLL string info access
extern "C" __declspec(dllexport) int __stdcall USBm_RecentError(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_ClearRecentError(void);
extern "C" __declspec(dllexport) int __stdcall USBm_DebugString(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Copyright(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_About(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Version(char *);





#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}



//---------------------------------------------------------------------------
// Display USB U4x1 information
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{

    unsigned char textstr[300];
    unsigned char numdev;
    unsigned char loop;

    // Title
    Form1->Debug->SetSelTextBuf("BCB USBm.dll link to lib example\n\n");

    // Discover the USBmicro devices
    USBm_FindDevices();

    // Numeric version of DLL
    Form1->Debug->SetSelTextBuf("USBm.dll version:\t");
    Form1->Debug->SelText = IntToStr(USBm_Version(textstr));
    Form1->Debug->SetSelTextBuf("\n");

    // String version of DLL
    Form1->Debug->SetSelTextBuf("USBm.dll version:\t");
    USBm_Version(textstr);
    Form1->Debug->SetSelTextBuf(textstr);
    Form1->Debug->SetSelTextBuf("\n");

    // USBmicro Copyright
    Form1->Debug->SetSelTextBuf("Copyright:\t");
    USBm_Copyright(textstr);
    Form1->Debug->SetSelTextBuf(textstr);
    Form1->Debug->SetSelTextBuf("\n");

    // About
    Form1->Debug->SetSelTextBuf("About:\t");
    USBm_About(textstr);
    Form1->Debug->SetSelTextBuf(textstr);
    Form1->Debug->SetSelTextBuf("\n\n");

    // Number of discovered devices
    numdev = USBm_NumberOfDevices();

    Form1->Debug->SetSelTextBuf("Number of devices:\t");
    Form1->Debug->SelText = IntToStr(numdev);
    Form1->Debug->SetSelTextBuf("\n\n");

    // Gather info from each discovered device
    for (loop = 0; loop < numdev; loop++)
        {

        // Vendor ID
        Form1->Debug->SetSelTextBuf("VID:\t");
        Form1->Debug->SelText = IntToStr(USBm_DeviceVID(loop));
        Form1->Debug->SetSelTextBuf("\n");

        // Manufacturer description
        Form1->Debug->SetSelTextBuf("Manuf:\t");
        USBm_DeviceMfr(loop, textstr);
        Form1->Debug->SetSelTextBuf(textstr);
        Form1->Debug->SetSelTextBuf("\n");

        // Product ID
        Form1->Debug->SetSelTextBuf("PID:\t");
        Form1->Debug->SelText = IntToStr(USBm_DevicePID(loop));
        Form1->Debug->SetSelTextBuf("\n");

        // Product description
        Form1->Debug->SetSelTextBuf("Prod:\t");
        USBm_DeviceProd(loop, textstr);
        Form1->Debug->SetSelTextBuf(textstr);
        Form1->Debug->SetSelTextBuf("\n");

        // Device ID (Firmware version)
        Form1->Debug->SetSelTextBuf("DID:\t");
        Form1->Debug->SelText = IntToStr(USBm_DeviceDID(loop)/256);
        Form1->Debug->SetSelTextBuf(".");
        Form1->Debug->SelText = IntToHex(  (USBm_DeviceDID(loop) - ((USBm_DeviceDID(loop)/256) * 256) ), 2 );
        Form1->Debug->SetSelTextBuf("\n");

        // Device serial number
        Form1->Debug->SetSelTextBuf("Serial:\t");
        USBm_DeviceSer(loop, textstr);
        Form1->Debug->SetSelTextBuf(textstr);
        Form1->Debug->SetSelTextBuf("\n");


        Form1->Debug->SetSelTextBuf("\n");
        }

    // Control individual devices

    // Device 1
    if (numdev > 0)
        {
        // Set first LED (d0) on first device
        USBm_InitPorts(0);
        USBm_DirectionA(0, 0xff, 0xff);
        USBm_SetBit(0, 0);
        }

    // Device 2
    if (numdev > 1)
        {
        // Set second LED (d1) on second device
        USBm_InitPorts(1);
        USBm_DirectionA(1, 0xff, 0xff);
        USBm_SetBit(1, 1);
        }

    // Device 3
    if (numdev > 2)
        {
        // Set third LED (d2) on third device
        USBm_InitPorts(2);
        USBm_DirectionA(2, 0xff, 0xff);
        USBm_SetBit(2, 2);
        }


}
//---------------------------------------------------------------------------
