
//*************************************************************************
//
// Author:           Robert Severson
//
// Creation Date:    2005-November
//
// Description:      BCB USBm.dll link to lib 1-wire example
//
// Copyright:        Copyright (C), Robert R. Severson 2005. All rights
//                   reserved. Created in the year 2005 as an unpublished
//                   copyright work. This program and the information
//                   contained in it is property of Robert R. Severson
//                   and may not be used, copied, or reproduced without
//                   prior written permission of Robert R. Severson
//
//                   This software remains the property of Robert R.
//                   Severson and is supplied under license only. The use
//                   of this software is permitted under the terms of that
//                   license only.
//
//*************************************************************************

#include <vcl.h>
#include <stdio.h>

#pragma hdrstop

#include "onewire.h"


// Discovery routine
extern "C" __declspec(dllexport) int __stdcall USBm_FindDevices(void);

// Info about devices
extern "C" __declspec(dllexport) int __stdcall USBm_NumberOfDevices(void);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceValid(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceVID(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DevicePID(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceDID(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceMfr(unsigned char, char *);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceProd(unsigned char, char *);
extern "C" __declspec(dllexport) int __stdcall USBm_DeviceSer(unsigned char, char *);

// General U4xx functions
extern "C" __declspec(dllexport) int __stdcall USBm_InitPorts(unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteA(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteB(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteABit(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_WriteBBit(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_ReadA(unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_ReadB(unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_SetBit(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_ResetBit(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DirectionA(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_DirectionB(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeWrite(unsigned char, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeRead(unsigned char, unsigned char *, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeWrite2(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeRead2(unsigned char, unsigned char *, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeWrites(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_StrobeReads(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_InitLCD(unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_LCDCmd(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_LCDData(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_InitSPI(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_SPIMaster(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_SPISlaveWrite(unsigned char, unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_SPISlaveRead(unsigned char, unsigned char *, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Stepper(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_Reset1Wire(unsigned char, unsigned char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Write1Wire(unsigned char, unsigned char);
extern "C" __declspec(dllexport) int __stdcall USBm_Read1Wire(unsigned char, unsigned char *);

// DLL string info access
extern "C" __declspec(dllexport) int __stdcall USBm_RecentError(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_ClearRecentError(void);
extern "C" __declspec(dllexport) int __stdcall USBm_DebugString(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Copyright(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_About(char *);
extern "C" __declspec(dllexport) int __stdcall USBm_Version(char *);





#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


unsigned char selectedU4x1;
unsigned char familycode;



//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}



//---------------------------------------------------------------------------
// Display USB U4x1 information
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{

    // Locals
    unsigned char textstr[300];
    unsigned char numdev;
    unsigned char loop;
    char* disp = new char[100];


    // Title
    Form1->Debug->SetSelTextBuf("BCB USBm.dll link to lib example\n\n");

    // Discover the USBmicro devices
    USBm_FindDevices();

    // Numeric version of DLL
    Form1->Debug->SetSelTextBuf("USBm.dll version:\t");
    Form1->Debug->SelText = IntToStr(USBm_Version(textstr));
    Form1->Debug->SetSelTextBuf("\n");

    // String version of DLL
    Form1->Debug->SetSelTextBuf("USBm.dll version:\t");
    USBm_Version(textstr);
    Form1->Debug->SetSelTextBuf(textstr);
    Form1->Debug->SetSelTextBuf("\n");

    // USBmicro Copyright
    Form1->Debug->SetSelTextBuf("Copyright:\t");
    USBm_Copyright(textstr);
    Form1->Debug->SetSelTextBuf(textstr);
    Form1->Debug->SetSelTextBuf("\n");

    // About
    Form1->Debug->SetSelTextBuf("About:\t");
    USBm_About(textstr);
    Form1->Debug->SetSelTextBuf(textstr);
    Form1->Debug->SetSelTextBuf("\n\n");

    // Number of discovered devices
    numdev = USBm_NumberOfDevices();

    Form1->Debug->SetSelTextBuf("Number of devices:\t");
    Form1->Debug->SelText = IntToStr(numdev);
    Form1->Debug->SetSelTextBuf("\n\n");

    // Gather info from each discovered device
    for (loop = 0; loop < numdev; loop++)
        {

        // Vendor ID
        Form1->Debug->SetSelTextBuf("VID:\t");
        Form1->Debug->SelText = IntToStr(USBm_DeviceVID(loop));
        Form1->Debug->SetSelTextBuf("\n");

        // Manufacturer description
        Form1->Debug->SetSelTextBuf("Manuf:\t");
        USBm_DeviceMfr(loop, textstr);
        Form1->Debug->SetSelTextBuf(textstr);
        Form1->Debug->SetSelTextBuf("\n");

        // Product ID
        Form1->Debug->SetSelTextBuf("PID:\t");
        Form1->Debug->SelText = IntToStr(USBm_DevicePID(loop));
        Form1->Debug->SetSelTextBuf("\n");

        // Product description
        Form1->Debug->SetSelTextBuf("Prod:\t");
        USBm_DeviceProd(loop, textstr);
        Form1->Debug->SetSelTextBuf(textstr);
        Form1->Debug->SetSelTextBuf("\n");

        // Device ID (Firmware version)
        Form1->Debug->SetSelTextBuf("DID:\t");
        Form1->Debug->SelText = IntToStr(USBm_DeviceDID(loop)/256);
        Form1->Debug->SetSelTextBuf(".");
        Form1->Debug->SelText = IntToHex(  (USBm_DeviceDID(loop) - ((USBm_DeviceDID(loop)/256) * 256) ), 2 );
        Form1->Debug->SetSelTextBuf("\n");

        // Device serial number
        Form1->Debug->SetSelTextBuf("Serial:\t");
        USBm_DeviceSer(loop, textstr);
        Form1->Debug->SetSelTextBuf(textstr);
        Form1->Debug->SetSelTextBuf("\n");


        Form1->Debug->SetSelTextBuf("\n");

        USBm_DeviceSer(loop, textstr);
        StrCopy(disp, textstr);
        u4x1seialnumber->AddItem(disp, Sender);

        }

    numdev = USBm_NumberOfDevices();
    if ( numdev > 0 )
        {
        u4x1seialnumber->ItemIndex = 0;
        selectedU4x1 = 0;
        }

    // Control individual devices

    // Device 1
    if (numdev > 0)
        {
        // Set first LED (d0) on first device
        USBm_InitPorts(0);
        USBm_DirectionA(0, 0xff, 0xff);
        USBm_SetBit(0, 0);
        }

    // Device 2
    if (numdev > 1)
        {
        // Set second LED (d1) on second device
        USBm_InitPorts(1);
        USBm_DirectionA(1, 0xff, 0xff);
        USBm_SetBit(1, 1);
        }

    // Device 3
    if (numdev > 2)
        {
        // Set third LED (d2) on third device
        USBm_InitPorts(2);
        USBm_DirectionA(2, 0xff, 0xff);
        USBm_SetBit(2, 2);
        }


} // FormCreate()




//---------------------------------------------------------------------------
//
// Exit Program
//
//---------------------------------------------------------------------------
void __fastcall TForm1::ExitClick(TObject *Sender)
{

    Close();


} // ExitClick()




//---------------------------------------------------------------------------
//
// Read Serial Number
//
//---------------------------------------------------------------------------
void __fastcall TForm1::readserialnumberClick(TObject *Sender)
{

    // Locals
    unsigned char pinx;
    unsigned char * pin;
    unsigned char data[8];
    char temp[20];


    pinx = pinselect->ItemIndex;
    pin = &pinx;

    // Reset device
    USBm_Reset1Wire( selectedU4x1, pin);

    // Write "ReadROM" command
    USBm_Write1Wire( selectedU4x1, 0x33);

    // Read family code
    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x", data[1]);
    FamilyCode->Text = temp;

    familycode = data[1];

    // Read serial number
    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x-", data[1]);
    Ser->Text = temp;

    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x-", data[1]);
    Ser->Text = Ser->Text + temp;

    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x-", data[1]);
    Ser->Text = Ser->Text + temp;

    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x-", data[1]);
    Ser->Text = Ser->Text + temp;

    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x-", data[1]);
    Ser->Text = Ser->Text + temp;

    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x", data[1]);
    Ser->Text = Ser->Text + temp;


    // Read CRC
    USBm_Read1Wire( selectedU4x1, data);
    sprintf(temp, "%2.2x", data[1]);
    CRC->Text = temp;

    readtemperature->Enabled = true;
    startconversion->Enabled = true;


} // readserialnumberClick()




//---------------------------------------------------------------------------
//
// Read Temperature
//
//---------------------------------------------------------------------------
void __fastcall TForm1::readtemperatureClick(TObject *Sender)
{

    // Locals
    unsigned char pinx;
    unsigned char * pin;
    unsigned char data[8];
    char temp[20];
    float comb;


    pinx = pinselect->ItemIndex;
    pin = &pinx;

    // Reset device
    USBm_Reset1Wire( selectedU4x1, pin );

    // Write "SkipRom" and "Read Scratchpad"
    USBm_Write1Wire( selectedU4x1, 0xCC);
    USBm_Write1Wire( selectedU4x1, 0xBE);


    // Process Family Code "10" ()
    if (familycode == 0x10)
        {
        // Read one byte of temperature
        USBm_Read1Wire( selectedU4x1, data);
        comb = data[1];

        // Display temperature
        sprintf(temp, "%f", comb/2);
        CTemperature->Text = temp;

        sprintf(temp, "%f", (comb/2)*1.8 + 32 );
        FTemperature->Text = temp;
        }


    // Process Family Code "28" (DS18B20)
    if (familycode == 0x28)
        {
        // Read two bytes of temperature
        USBm_Read1Wire( selectedU4x1, data);
        comb = data[1];

        USBm_Read1Wire( selectedU4x1, data);
        comb = comb + ( (data[1] & 0x07) * 256);

        // Display temperature
        sprintf(temp, "%f", comb/16);
        CTemperature->Text = temp;

        sprintf(temp, "%f", (comb/16)*1.8 + 32 );
        FTemperature->Text = temp;
        }


    // Process Family Code "22" (DS18B22)
    if (familycode == 0x22)
        {
        // Read two bytes of temperature
        USBm_Read1Wire( selectedU4x1, data);
        comb = data[1];

        USBm_Read1Wire( selectedU4x1, data);
        comb = comb + ( (data[1] & 0x07) * 256);

        // Display temperature
        sprintf(temp, "%f", comb/16);
        CTemperature->Text = temp;

        sprintf(temp, "%f", (comb/16)*1.8 + 32 );
        FTemperature->Text = temp;
        }


} // readtemperatureClick()




//---------------------------------------------------------------------------
//
// Start Conversion
//
//---------------------------------------------------------------------------
void __fastcall TForm1::startconversionClick(TObject *Sender)
{

    // Locals
    unsigned char pinx;
    unsigned char * pin;


    pinx = pinselect->ItemIndex;
    pin = &pinx;

    // Reset device
    USBm_Reset1Wire( selectedU4x1, pin );

    // Write "SkipRom" and "Conversion" command
    USBm_Write1Wire( selectedU4x1, 0xCC);
    USBm_Write1Wire( selectedU4x1, 0x44);


} // startconversionClick()




//---------------------------------------------------------------------------
//
// Act on selection of U4x1
//
//---------------------------------------------------------------------------
void __fastcall TForm1::U4x1selection(TObject *Sender)
{

    selectedU4x1 = u4x1seialnumber->ItemIndex;

} // U4x1selection()




//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{

    unsigned char pinx;
    unsigned char * pin;

    Form1->Debug->SetSelTextBuf("T1 ");

//    Timer1->Enabled = false;
    Timer2->Enabled = true;

    pinx = pinselect->ItemIndex;
    pin = &pinx;

    // Reset device
    USBm_Reset1Wire( selectedU4x1, pin );

    // Write "SkipRom" and "Conversion" command
    USBm_Write1Wire( selectedU4x1, 0xCC);
    USBm_Write1Wire( selectedU4x1, 0x44);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{

    unsigned char pinx;
    unsigned char * pin;


//    Timer2->Enabled = false;
    Timer1->Enabled = true;

    Form1->Debug->SetSelTextBuf("T2 ");

    pinx = pinselect->ItemIndex;
    pin = &pinx;


    // Write "SkipRom" and "Read Scratchpad"
    USBm_Write1Wire( selectedU4x1, 0xCC);
    USBm_Write1Wire( selectedU4x1, 0xBE);


    // Process Family Code "10" ()
    if (familycode == 0x10)
        {
        // Read one byte of temperature
        USBm_Read1Wire( selectedU4x1, data);
        comb = data[1];

        // Display temperature
        sprintf(temp, "%f", comb/2);
        CTemperature->Text = temp;

        sprintf(temp, "%f", (comb/2)*1.8 + 32 );
        FTemperature->Text = temp;
        }


    // Process Family Code "28" (DS18B20)
    if (familycode == 0x28)
        {
        // Read two bytes of temperature
        USBm_Read1Wire( selectedU4x1, data);
        comb = data[1];

        USBm_Read1Wire( selectedU4x1, data);
        comb = comb + ( (data[1] & 0x07) * 256);

        // Display temperature
        sprintf(temp, "%f", comb/16);
        CTemperature->Text = temp;

        sprintf(temp, "%f", (comb/16)*1.8 + 32 );
        FTemperature->Text = temp;
        }


    // Process Family Code "22" (DS18B22)
    if (familycode == 0x22)
        {
        // Read two bytes of temperature
        USBm_Read1Wire( selectedU4x1, data);
        comb = data[1];

        USBm_Read1Wire( selectedU4x1, data);
        comb = comb + ( (data[1] & 0x07) * 256);

        // Display temperature
        sprintf(temp, "%f", comb/16);
        CTemperature->Text = temp;

        sprintf(temp, "%f", (comb/16)*1.8 + 32 );
        FTemperature->Text = temp;
        }



}
//---------------------------------------------------------------------------

